    001/* ===========================================================
    002 * Orson Charts : a 3D chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C)opyright 2013-2022, by David Gilbert.  All rights reserved.
    006 *
    007 * https://github.com/jfree/orson-charts
    008 *
    009 * This program is free software: you can redistribute it and/or modify
    010 * it under the terms of the GNU General Public License as published by
    011 * the Free Software Foundation, either version 3 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This program is distributed in the hope that it will be useful,
    015 * but WITHOUT ANY WARRANTY; without even the implied warranty of
    016 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    017 * GNU General Public License for more details.
    018 *
    019 * You should have received a copy of the GNU General Public License
    020 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
    021 *
    022 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    023 * Other names may be trademarks of their respective owners.]
    024 *
    025 * If you do not wish to be bound by the terms of the GPL, an alternative
    026 * commercial license can be purchased.  For details, please see visit the
    027 * Orson Charts home page:
    028 *
    029 * http://www.object-refinery.com/orsoncharts/index.html
    030 *
    031 */
    032
    033package org.jfree.chart3d.data;
    034
    035/**
    036 * A generic representation of a three dimensional grid (cube) of data values.
    037 * We refer to the indices in the three dimensions as the
    038 * {@code seriesIndex}, the {@code rowIndex} and the
    039 * {@code columnIndex} (to match the downstream use of this data
    040 * structure to represent data values in a three dimensional plot).
    041 *
    042 * @param <T> The value type (normally a numeric type).
    043 *
    044 * @see KeyedValues3D
    045 */
    046public interface Values3D<T> {
    047
    048    /**
    049     * Returns the number of items in the x-dimension.
    050     *
    051     * @return The number of items in the x-dimension.
    052     */
    053    int getSeriesCount();
    054
    055    /**
    056     * Returns the number of items in the y-dimension.
    057     *
    058     * @return The number of items in the y-dimension.
    059     */
    060    int getRowCount();
    061
    062    /**
    063     * Returns the number of items in the z-dimension.
    064     *
    065     * @return The number of items in the z-dimension.
    066     */
    067    int getColumnCount();
    068
    069    /**
    070     * Returns the data item at the specified position.
    071     *
    072     * @param seriesIndex  the series-index.
    073     * @param rowIndex  the row-index.
    074     * @param columnIndex  the column-index.
    075     *
    076     * @return The data value (possibly {@code null}).
    077     */
    078    T getValue(int seriesIndex, int rowIndex, int columnIndex);
    079
    080    /**
    081     * Returns the data item at the specified position as a double primitive.
    082     * Where the {@link #getValue(int, int, int) } method returns
    083     * {@code null}, this method returns {@code Double.NaN}.
    084     *
    085     * @param seriesIndex  the series index.
    086     * @param rowIndex  the row index.
    087     * @param columnIndex  the column index.
    088     *
    089     * @return The data value.
    090     */
    091    double getDoubleValue(int seriesIndex, int rowIndex, int columnIndex);
    092
    093}